package net.mc_pandacraft.java.plugin.pandacraftutils.commands;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;

import net.mc_pandacraft.java.plugin.pandacraftutils.config.ConfigManager;
import net.mc_pandacraft.java.plugin.pandacraftutils.data_model.ModoHistoryElement;
import net.mc_pandacraft.java.plugin.pandacraftutils.data_model.ModoHistoryElement.ActionType;
import net.mc_pandacraft.java.plugin.pandacraftutils.players.OnlinePlayer;
import net.mc_pandacraft.java.plugin.pandacraftutils.players.OnlinePlayerManager;
import net.mc_pandacraft.java.plugin.pandacraftutils.plugin_interface.EssentialsInterface;
import net.mc_pandacraft.java.util.TimeUtil;

import org.bukkit.BanList.Type;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.util.Vector;

import com.earth2me.essentials.User;
import com.earth2me.essentials.utils.DateUtil;

public class CommandModo extends AbstractCommandExecutor {
	
	
	public CommandModo() {
		super("modo");
	}
	

	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label,
			String[] args) {
		
		
		
		// affichage de l'aide
		if (args.length == 0 || args[0].matches("[0-9]+")) {
			
			int page = 1;
			
			if (args.length == 1)
				try {
					page = Integer.parseInt(args[0]);
				} catch (NumberFormatException e) { }
			
			showHelp(sender, page);
			
			return true;
			
		}
		
		
		
		/*
		 * report
		 */
		
		if (args.length >= 3 && args[0].equalsIgnoreCase("report")) {
			String player = args[1];
			
			String message = getLastParam(args, 2);
			
			onCommandReport(sender, player, message);
			
			return true;
			
		}
		
		/*
		 * jails
		 */
		
		if (args.length >= 1 && args[0].equalsIgnoreCase("jails")) {
			
			if (!(sender instanceof Player))
			{
				sender.sendMessage(ChatColor.RED+"Vous devez être en ligne pour faire cette sous-commande");
				return true;
			}
			
			onCommandJails((Player) sender);
			
			return true;
		}
		
		/*
		 * amende
		 */
		if (args.length >= 4 && args[0].equalsIgnoreCase("amende")) {
			
			String player = args[1];
			
			long somme = 0;
			
			try {
				somme = Long.parseLong(args[2]);
			} catch(NumberFormatException e) {
				sender.sendMessage(ChatColor.RED+"La somme d'argent à retirer n'est pas valide");
				return true;
			}
			
			String message = getLastParam(args, 3);
			
			onCommandAmende(sender, player, somme, message);
			
			return true;
		}
		
		/*
		 * kick
		 */
		if (args.length >= 3 && args[0].equalsIgnoreCase("kick")) {
			String player = args[1];
			
			String message = getLastParam(args, 2);
			
			onCommandKick(sender, player, message);
			
			return true;
			
		}
		
		/*
		 * ban
		 */
		if (args.length >= 4 && args[0].equalsIgnoreCase("ban")) {
			
			String player = args[1];
			
			long duree;
			
			try {
				duree = Math.round((DateUtil.parseDateDiff(args[2], true)-System.currentTimeMillis())/1000D);
			} catch(Exception e) {
				// l'exception est généré par Essentials, qui rend le message User Friendly
				sender.sendMessage(ChatColor.RED+e.getMessage());
				return true;
			}
			
			String message = getLastParam(args, 3);
			
			onCommandBan(sender, player, duree, message);
			
			return true;
		}
		
		/*
		 * unban
		 */
		if (args.length >= 3 && args[0].equalsIgnoreCase("unban")) {
			String player = args[1];
			
			String message = getLastParam(args, 2);
			
			onCommandUnban(sender, player, message);
			
			return true;
			
		}
		
		/*
		 * mute
		 */
		if (args.length >= 4 && args[0].equalsIgnoreCase("mute")) {
			
			String player = args[1];
			
			long duree;
			
			try {
				duree = Math.round((DateUtil.parseDateDiff(args[2], true)-System.currentTimeMillis())/1000D);
			} catch(Exception e) {
				// l'exception est généré par Essentials, qui rend le message User Friendly
				sender.sendMessage(ChatColor.RED+e.getMessage());
				return true;
			}
			
			String message = getLastParam(args, 3);
			
			onCommandMute(sender, player, duree, message);
			
			return true;
		}
		
		/*
		 * unmute
		 */
		if (args.length >= 3 && args[0].equalsIgnoreCase("unmute")) {
			String player = args[1];
			
			String message = getLastParam(args, 2);
			
			onCommandUnmute(sender, player, message);
			
			return true;
			
		}
		
		/*
		 * jail
		 */
		if (args.length >= 4 && args[0].equalsIgnoreCase("jail")) {
			
			String player = args[1];
			
			long duree;
			
			try {
				duree = Math.round((DateUtil.parseDateDiff(args[2], true)-System.currentTimeMillis())/1000D);
			} catch(Exception e) {
				// l'exception est généré par Essentials, qui rend le message User Friendly
				sender.sendMessage(ChatColor.RED+e.getMessage());
				return true;
			}
			
			String message = getLastParam(args, 3);
			
			onCommandJail(sender, player, duree, message);
			
			return true;
		}
		
		/*
		 * unjail
		 */
		if (args.length >= 3 && args[0].equalsIgnoreCase("unmute")) {
			String player = args[1];
			
			String message = getLastParam(args, 2);
			
			onCommandUnjail(sender, player, message);
			
			return true;
			
		}
		
		
		
		
		sender.sendMessage(ChatColor.RED+"Mauvaise utilisation de la commande : Faites "+ChatColor.GRAY+"/modo"+ChatColor.RED+" pour afficher l'aide.");
		
		
		return true;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	private void onCommandReport(CommandSender sender, String player, String message) {
		
		player = getRealNameIfWasAlreadyOnline(player);
		
		if (player == null) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué n'existe pas");
			return;
		}
		
		ModoHistoryElement historyEl = new ModoHistoryElement(sender.getName(), ActionType.REPORT, player, message);
		historyEl.save();
		
		broadcastModoMessage(sender.getName(), " viens de report ", player, " pour ", message);
	}
	
	
	
	
	private void onCommandJails(Player sender) {
		
		Vector v = ConfigManager.getInstance().defaultConfig.modo_jailsPosition_coords;
		World w = plugin.getServer().getWorld(ConfigManager.getInstance().defaultConfig.modo_jailsPosition_world);
		
		sender.teleport(new Location(w, v.getX(), v.getY(), v.getZ()));
	}
	
	
	
	
	
	private void onCommandAmende(CommandSender sender, String player, long somme, String message) {
		
		if (!hasCommandSenderPermissionLevel(sender, ModoPermissionLevel.HIGH)) {
			sender.sendMessage(ChatColor.RED+"Vous n'avez pas le niveau de permission suffisant pour exécuter cette sous-commande");
			return;
		}
		
		player = getRealNameIfWasAlreadyOnline(player);
		
		if (player == null) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué n'existe pas");
			return;
		}
		
		
		User u = EssentialsInterface.getPlugin().getOfflineUser(player);
		
		if (u.isAuthorized("pandacraft.modo") && !hasCommandSenderPermissionLevel(sender, ModoPermissionLevel.HIGH)) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué est protégé contre les sanctions");
			return;
		}
		
		if (somme < 0) {
			sender.sendMessage(ChatColor.RED+"La somme indiquée doit être positive");
			return;
		}
		
		double actualMoney = u.getMoney().doubleValue();
		long moneyToRemove = somme;
		
		if (somme > actualMoney) {
			moneyToRemove = (long) actualMoney;
			double newMoney = actualMoney - moneyToRemove;
			u.setMoney(new BigDecimal(newMoney));
			
			message = message + " (manque "+(somme - moneyToRemove)+" P à retirer)";
			
			ModoHistoryElement historyEl = new ModoHistoryElement(sender.getName(), ActionType.MONEY, player, message);
			historyEl.setValue(moneyToRemove);
			historyEl.save();
			
		}
		else {
			double newMoney = actualMoney - moneyToRemove;
			u.setMoney(new BigDecimal(newMoney));

			ModoHistoryElement historyEl = new ModoHistoryElement(sender.getName(), ActionType.MONEY, player, message);
			historyEl.setValue(somme);
			historyEl.save();
		}
		
		
		broadcastModoMessage(sender.getName(), " viens d'appliquer une amende de ", String.valueOf(moneyToRemove), "P à ", player, " pour ", message);
		
	}
	
	
	
	
	private void onCommandKick(CommandSender sender, String player, String message) {

		if (!hasCommandSenderPermissionLevel(sender, ModoPermissionLevel.LOW)) {
			sender.sendMessage(ChatColor.RED+"Vous n'avez pas le niveau de permission suffisant pour exécuter cette sous-commande");
			return;
		}
		

		Player p = plugin.getServer().getPlayer(player);
		
		if (p == null || !p.isOnline() || (sender instanceof Player && !((Player)sender).canSee(p))) { // la dernière condition protège les joueurs vanish
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué n'est pas en ligne");
			return;
		}
		
		if (p.hasPermission("pandacraft.modo") && !hasCommandSenderPermissionLevel(sender, ModoPermissionLevel.HIGH)) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué est protégé contre les sanctions");
			return;
		}
		
		
		
		player = p.getName();
		
		
		p.kickPlayer(message);
		
		ModoHistoryElement historyEl = new ModoHistoryElement(sender.getName(), ActionType.KICK, player, message);
		historyEl.save();
		
		broadcastModoMessage(sender.getName(), " viens d'expulser ", player, " pour ", message);
		
		
	}
	
	
	
	
	
	/**
	 * @param duration en seconde
	 */
	private void onCommandBan(CommandSender sender, String player, long duration, String message) {
		// vérification des droits d'exécution
		if (!hasCommandSenderPermissionLevel(sender, ModoPermissionLevel.LOW)) {
			sender.sendMessage(ChatColor.RED+"Vous n'avez pas le niveau de permission suffisant pour exécuter cette sous-commande");
			return;
		}
		
		// vérification du joueur indiqué
		player = getRealNameIfWasAlreadyOnline(player);
		
		if (player == null) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué n'existe pas");
			return;
		}
		
		User u = EssentialsInterface.getPlugin().getOfflineUser(player);
		
		// on vérifie si le joueur est protégé contre les sanctions
		if (u.isAuthorized("pandacraft.modo") && !hasCommandSenderPermissionLevel(sender, ModoPermissionLevel.HIGH)) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué est protégé contre les sanctions");
			return;
		}
		// on vérifie si le joueur est déjà banni
		if (plugin.getServer().getBanList(Type.NAME).isBanned(player)) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué est déjà banni");
			return;
		}
		
		
		// vérification des droits sur la durée
		duration = correctPermittedDuration(sender, duration);

		Date expire = new Date(System.currentTimeMillis()+(duration*1000));
		
		// application de la sanction
		plugin.getServer().getBanList(Type.NAME).addBan(player, message, expire, sender.getName());
		
		// enregistrement de l'action
		ModoHistoryElement historyEl = new ModoHistoryElement(sender.getName(), ActionType.BAN, player, message);
		historyEl.setValue(duration);
		historyEl.save();
		
		// diffusion
		broadcastModoMessage(sender.getName(), " viens de bannir ", player, " pendant ", TimeUtil.durationToString(duration*1000), " pour ", message);
		
	}
	
	
	
	
	
	
	private void onCommandUnban(CommandSender sender, String player, String message) {
		// vérification des droits d'exécution
		if (!hasCommandSenderPermissionLevel(sender, ModoPermissionLevel.LOW)) {
			sender.sendMessage(ChatColor.RED+"Vous n'avez pas le niveau de permission suffisant pour exécuter cette sous-commande");
			return;
		}
		
		/* on a pas besoin de vérifier si le joueur a déjà existé, car c'est
		 * forcément le cas, si le joueur a déjà été banni
		 */

		// on vérifie si le joueur est déjà banni
		if (!plugin.getServer().getBanList(Type.NAME).isBanned(player)) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué n'est pas banni");
			return;
		}
		
		// application du retrait de sanction
		plugin.getServer().getBanList(Type.NAME).pardon(player);

		// enregistrement de l'action
		ModoHistoryElement historyEl = new ModoHistoryElement(sender.getName(), ActionType.UNBAN, player, message);
		historyEl.save();

		// diffusion
		broadcastModoMessage(sender.getName(), " viens de débannir ", player, " pour ", message);
		
	}
	
	
	
	
	
	
	
	

	
	/**
	 * @param duration en seconde
	 */
	private void onCommandMute(CommandSender sender, String player, long duration, String message) {
		// vérification des droits d'exécution
		if (!hasCommandSenderPermissionLevel(sender, ModoPermissionLevel.LOW)) {
			sender.sendMessage(ChatColor.RED+"Vous n'avez pas le niveau de permission suffisant pour exécuter cette sous-commande");
			return;
		}
		
		// vérification du joueur indiqué
		player = getRealNameIfWasAlreadyOnline(player);
		
		if (player == null) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué n'existe pas");
			return;
		}
		
		User u = EssentialsInterface.getPlugin().getOfflineUser(player);
		
		// on vérifie si le joueur est protégé contre les sanctions
		if (u.isAuthorized("pandacraft.modo") && !hasCommandSenderPermissionLevel(sender, ModoPermissionLevel.HIGH)) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué est protégé contre les sanctions");
			return;
		}
		// on vérifie si le joueur est déjà mute
		if (u.isMuted()) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué est déjà muet");
			return;
		}
		
		
		// vérification des droits sur la durée
		duration = correctPermittedDuration(sender, duration);

		Date expire = new Date(System.currentTimeMillis()+(duration*1000));
		
		// application de la sanction
		u.setMuted(true);
		u.setMuteTimeout(expire.getTime());
		
		// enregistrement de l'action
		ModoHistoryElement historyEl = new ModoHistoryElement(sender.getName(), ActionType.MUTE, player, message);
		historyEl.setValue(duration);
		historyEl.save();
		
		// diffusion
		broadcastModoMessage(sender.getName(), " viens de rendre muet ", player, " pendant ", TimeUtil.durationToString(duration*1000), " pour ", message);
		
	}
	
	
	
	
	
	
	private void onCommandUnmute(CommandSender sender, String player, String message) {
		// vérification des droits d'exécution
		if (!hasCommandSenderPermissionLevel(sender, ModoPermissionLevel.LOW)) {
			sender.sendMessage(ChatColor.RED+"Vous n'avez pas le niveau de permission suffisant pour exécuter cette sous-commande");
			return;
		}
		
		// vérification du joueur indiqué
		player = getRealNameIfWasAlreadyOnline(player);
		
		if (player == null) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué n'existe pas");
			return;
		}
		
		User u = EssentialsInterface.getPlugin().getOfflineUser(player);

		// on vérifie si le joueur est déjà mute
		if (!u.isMuted()) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué n'est pas mute");
			return;
		}
		
		// application du retrait de sanction
		u.setMuted(false);
		u.setMuteTimeout(0);

		// enregistrement de l'action
		ModoHistoryElement historyEl = new ModoHistoryElement(sender.getName(), ActionType.UNMUTE, player, message);
		historyEl.save();

		// diffusion
		broadcastModoMessage(sender.getName(), " viens de rendre la parole à ", player, " pour ", message);
		
	}
	
	
	
	
	
	
	
	

	
	

	
	/**
	 * @param duration en seconde
	 */
	private void onCommandJail(CommandSender sender, String player, long duration, String message) {
		// vérification des droits d'exécution
		if (!hasCommandSenderPermissionLevel(sender, ModoPermissionLevel.LOW)) {
			sender.sendMessage(ChatColor.RED+"Vous n'avez pas le niveau de permission suffisant pour exécuter cette sous-commande");
			return;
		}
		
		// vérification du joueur indiqué
		player = getRealNameIfWasAlreadyOnline(player);
		
		if (player == null) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué n'existe pas");
			return;
		}
		
		User u = EssentialsInterface.getPlugin().getOfflineUser(player);
		
		// on vérifie si le joueur est protégé contre les sanctions
		if (u.isAuthorized("pandacraft.modo") && !hasCommandSenderPermissionLevel(sender, ModoPermissionLevel.HIGH)) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué est protégé contre les sanctions");
			return;
		}
		
		
		// vérification des droits sur la durée
		duration = correctPermittedDuration(sender, duration);
		
		// application de la sanction
		boolean ok = plugin.jailsManager.addJailedPlayer(u, message, duration);
		
		if (!ok) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué ne peut pas être emprisonné");
			return;
		}
		
		// enregistrement de l'action
		ModoHistoryElement historyEl = new ModoHistoryElement(sender.getName(), ActionType.JAIL, player, message);
		historyEl.setValue(duration);
		historyEl.save();
		
		// diffusion
		broadcastModoMessage(sender.getName(), " viens d'emprisonner ", player, " pendant ", TimeUtil.durationToString(duration*1000), " pour ", message);
		
	}
	
	
	
	
	
	
	private void onCommandUnjail(CommandSender sender, String player, String message) {
		// vérification des droits d'exécution
		if (!hasCommandSenderPermissionLevel(sender, ModoPermissionLevel.LOW)) {
			sender.sendMessage(ChatColor.RED+"Vous n'avez pas le niveau de permission suffisant pour exécuter cette sous-commande");
			return;
		}
		
		// vérification du joueur indiqué
		player = getRealNameIfWasAlreadyOnline(player);
		
		if (player == null) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué n'existe pas");
			return;
		}
		
		User u = EssentialsInterface.getPlugin().getOfflineUser(player);
		
		// application du retrait de sanction
		boolean ok = plugin.jailsManager.removeJailedPlayer(u);
		
		if (!ok) {
			sender.sendMessage(ChatColor.RED+"Le joueur indiqué ne peut pas être libéré (il n'est peut-être pas en prison)");
			return;
		}
		
		// enregistrement de l'action
		ModoHistoryElement historyEl = new ModoHistoryElement(sender.getName(), ActionType.UNJAIL, player, message);
		historyEl.save();

		// diffusion
		broadcastModoMessage(sender.getName(), " viens de libérer ", player, " pour ", message);
		
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	private void showHelp(CommandSender sender, int page) {
		ArrayList<String> s = new ArrayList<String>();
		
		s.add(ChatColor.GOLD+"-------- Assistant de modération --------");
		
		
		
		if (page == 1) {
			s.add(ChatColor.GOLD+"- Commandes sans sanction :");
			s.add(ChatColor.GRAY+"/modo report <Pseudo> <Raison>"+ChatColor.WHITE+" faire un rapport d'un joueur, sans appliquer de sanction");
			s.add(ChatColor.GRAY+"/modo jails"+ChatColor.WHITE+" aller à la prison");
			s.add(ChatColor.GOLD+"- Aide sur les commandes de sanction :");
			s.add(ChatColor.GRAY+"/modo 2"+ChatColor.WHITE+" application d'une sanction");
			s.add(ChatColor.GRAY+"/modo 3"+ChatColor.WHITE+" retrait d'une sanction");
			s.add(ChatColor.GRAY+"/modo 4"+ChatColor.WHITE+" règles sur les sanctions");
		}
		else if (page == 2) {
			s.add(ChatColor.GOLD+"- Appliquer une sanction :");
			s.add(ChatColor.GRAY+"/modo jail <Pseudo> <Durée> <Raison>"+ChatColor.WHITE+" emprisonner un <Joueur> pendant une <Durée> en précisant la <Raison>");
			s.add(ChatColor.GRAY+"/modo mute <Pseudo> <Durée> <Raison>"+ChatColor.WHITE+" rendre muet un <Joueur> pendant une <Durée> en précisant la <Raison>");
			s.add(ChatColor.GRAY+"/modo ban <Pseudo> <Durée> <Raison>"+ChatColor.WHITE+" bannir un <Joueur> pendant une <Durée> en précisant la <Raison>");
			s.add(ChatColor.GRAY+"/modo kick <Pseudo> <Raison>"+ChatColor.WHITE+" expulse un <Joueur> en précisant la <Raison>");
			s.add(ChatColor.GRAY+"/modo amende <Pseudo> <Raison>"+ChatColor.WHITE+" expulse un <Joueur> en précisant la <Raison>");
		}
		else if (page == 3) {
			s.add(ChatColor.GOLD+"- Retirer une sanction :");
			s.add(ChatColor.GRAY+"/modo unjail <Pseudo> <Raison>"+ChatColor.WHITE+" sortir de prison un <Joueur> en précisant la <Raison>");
			s.add(ChatColor.GRAY+"/modo unmute <Pseudo> <Raison>"+ChatColor.WHITE+" rendre la parole à un <Joueur> en précisant la <Raison>");
			s.add(ChatColor.GRAY+"/modo unban <Pseudo> <Raison>"+ChatColor.WHITE+" retirer le banissement d'un <Joueur> en précisant la <Raison>");
		}
		else if (page == 4) {
			s.add(ChatColor.GOLD+"- Règles sur les sanctions :");
			s.add(ChatColor.WHITE+"- Certains membres du staff on plus ou moins de droits concernant les sanctions (durée de jail, ban et mute)");
			s.add(ChatColor.WHITE+"- Toutes les sanctions doivent être justifiées. Vous êtes obligé d'indiquer la raison de la sanction dans les commandes");
			s.add(ChatColor.WHITE+"- Toutes les actions dans la commande "+ChatColor.GRAY+"/modo"+ChatColor.WHITE+" sont enregistrées");
			s.add(ChatColor.WHITE+"- Rendez vous sur MineAdmin pour les autres règles de Modération");
			s.add(ChatColor.WHITE+"- Rendez vous sur le site web de Pandacraft pour le règlement du serveur et les sanctions à appliquer");
		}
		else {
			s.add(ChatColor.GOLD+"La page "+page+" n'existe pas");
		}
		
		s.add(ChatColor.GOLD+"------------------------------------------");
		
		sender.sendMessage(s.toArray(new String[s.size()]));
	}
	
	
	
	
	
	
	
	
	
	
	
	private long correctPermittedDuration(CommandSender sender, long duration) {
		
		if (!hasCommandSenderPermissionLevel(sender, ModoPermissionLevel.NORMAL) && duration > ConfigManager.getInstance().defaultConfig.modo_durationLimit_low) {
			duration = ConfigManager.getInstance().defaultConfig.modo_durationLimit_low;
			sender.sendMessage(ChatColor.RED+"Vous n'avez pas le niveau de permission suffisant pour sanctionner sur une durée aussi longue");
			sender.sendMessage(ChatColor.RED+"La durée a été réduite à" + TimeUtil.durationToString(duration*1000));
		}

		else if (!hasCommandSenderPermissionLevel(sender, ModoPermissionLevel.HIGH) && duration > ConfigManager.getInstance().defaultConfig.modo_durationLimit_normal) {
			duration = ConfigManager.getInstance().defaultConfig.modo_durationLimit_normal;
			sender.sendMessage(ChatColor.RED+"Vous n'avez pas le niveau de permission suffisant pour sanctionner sur une durée aussi longue");
			sender.sendMessage(ChatColor.RED+"La durée a été réduite à" + TimeUtil.durationToString(duration*1000));
		}
		
		return duration;
	}
	
	
	
	
	
	
	/**
	 * Retourne le nom du joueur avec la casse corrigée, ou null si le joueur n'est pas dans les données Essentials
	 * @param player
	 * @return le pseudo corrigé ou null
	 */
	protected String getRealNameIfWasAlreadyOnline(String player) {
		
		User u = EssentialsInterface.getPlugin().getOfflineUser(player);
		
		if (u == null) {
			return null;
		}
		
		return u.getName(); // correction du nom (majuscule) si Essentials effectue une correction
		
	}
	
	
	
	/**
	 * Diffuse un message destiné au staff ayant les droits de modération.<br/>
	 * Ce message est préfixé de [Modération].<br/>
	 * Les 1er, 3ème, 5ème, ... paramètres sont colorés en gris, et 2ème, 4ème, 6ème, ... paramètres
	 * sont colorés en blanc. Ces paramètres sont ensuite concaténé pour former le message final.
	 * @param messages
	 */
	protected void broadcastModoMessage(String ... messages) {
		boolean colorToggle = true;
		StringBuilder sb = new StringBuilder();
		for (String message : messages) {
			sb.append(colorToggle?ChatColor.GRAY:ChatColor.RESET);
			
			sb.append(message);
			
			colorToggle = !colorToggle;
		}
		plugin.broadcast("["+ChatColor.GREEN+"Modération"+ChatColor.RESET+"] "+sb.toString(), false, true, "pandacraft.modo");
	}
	
	
	
	
	
	protected ModoPermissionLevel getPermissionLevel(OnlinePlayer op) {
		if (op == null) return null;
		
		ModoPermissionLevel highestLevel = null;
		
		for (ModoPermissionLevel level : ModoPermissionLevel.values()) {
			if (op.hasPermission("pandacrat.modo."+level.name().toLowerCase()))
				if (highestLevel == null || level.level >= highestLevel.level)
					highestLevel = level;
		}
		
		return highestLevel;
		
		
	}
	
	
	protected boolean hasCommandSenderPermissionLevel(CommandSender sender, ModoPermissionLevel level) {
		if (sender == null || level == null) return false;
		if (!(sender instanceof Player)) return true;
		OnlinePlayer op = OnlinePlayerManager.get((Player)sender);
		ModoPermissionLevel levelPlayer = getPermissionLevel(op);
		return (levelPlayer != null && (levelPlayer.level >= level.level));
	}
	
	
	
	
	public enum ModoPermissionLevel{
		HIGH(2), NORMAL(1), LOW(0);
		
		private ModoPermissionLevel(int l) {
			level = l;
		}
		
		public final int level;
	}
	

}
