package net.mc_pandacraft.java.plugin.pandacraftutils.modules;

import net.mc_pandacraft.java.plugin.pandacraftutils.PandacraftUtils;
import net.mc_pandacraft.java.plugin.pandacraftutils.players.OnlinePlayerManager;
import net.mc_pandacraft.java.plugin.pandacraftutils.plugin_interface.EssentialsInterface;

import org.bukkit.ChatColor;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;

import de.luricos.bukkit.xAuth.events.xAuthLoginEvent;

public class LoginLogoutMessageManager implements Listener {

	private PandacraftUtils plugin = PandacraftUtils.getInstance();
	
	
	public LoginLogoutMessageManager() {
		
		plugin.getServer().getPluginManager().registerEvents(this, plugin);
	}
	
	
	@EventHandler
	public void onPlayerJoin(PlayerJoinEvent event) {
		event.setJoinMessage(null);
	}
	
	
	@EventHandler
	public void onxAuthLogin(xAuthLoginEvent event) {
		
		if (EssentialsInterface.isPlayerVanished(event.getPlayer())) return;
		
		plugin.getServer().broadcastMessage(ChatColor.YELLOW+event.getPlayer().getDisplayName()+ChatColor.YELLOW+" vient de se connecter");
	}
	
	@EventHandler
	public void onPlayerQuit(PlayerQuitEvent event) {
		event.setQuitMessage(null);
		
		if (!OnlinePlayerManager.get(event.getPlayer()).isAuthenticated())
			return;
		
		// on affiche le message que si le joueur n'est pas vanish
		if (EssentialsInterface.isPlayerVanished(event.getPlayer())) return;
		
		plugin.getServer().broadcastMessage(ChatColor.YELLOW+event.getPlayer().getDisplayName()+ChatColor.YELLOW+" a quitté le jeu");
	}
	
	
	
}
